## utox 0.17.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(uTox LANGUAGES C)

#####################
## Project Metadata #
#####################

set(PROJECT_VERSION_MAJOR "0")
set(PROJECT_VERSION_MINOR "17")
set(PROJECT_VERSION_PATCH "1")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

set(PROJECT_COPYRIGHT "Copyleft 2019 uTox contributors. Some rights reserved.")

string(TIMESTAMP BUILD_YEAR "%Y" UTC)
string(TIMESTAMP BUILD_MONTH "%B" UTC)

########################
# Set helper-variables #
########################

# OS
if(CYGWIN)
    # Cygwin thinks it's actually Linux.
    set(WIN32 TRUE)
    set(UNIX FALSE)
endif()

if(WIN32)
    set(WINDOWS TRUE)
elseif(APPLE)
    if(CMAKE_SYSTEM_NAME MATCHES ".*MacOS.*")
        set(CMAKE_OSX_DEPLOYMENT_TARGET 10.6 CACHE STRING "Minimum OS X deployment version")
        set(MACOSX TRUE)
    endif()
elseif(UNIX)
    if(CMAKE_SYSTEM_NAME MATCHES ".*Linux")
        set(LINUX TRUE)
    elseif(CMAKE_SYSTEM_NAME MATCHES "kNetBSD.*|NetBSD.*")
        set(NETBSD TRUE)
    elseif(CMAKE_SYSTEM_NAME MATCHES "kFreeBSD.*|FreeBSD")
        set(FREEBSD TRUE)
    endif()
endif()

# 32 or 64 bit
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ARCH_64 TRUE)
else()
  set(ARCH_64 FALSE)
endif()



#############################
# System-dependent defaults #
#############################

# Windows only compiles statically.
if (WINDOWS)
    set(STATIC_DEFAULT ON)
else()
    set(STATIC_DEFAULT OFF)
endif()

# Disable ASAN for macOS due to "AddressSanitizer: odr-violation: global". see #957
# Windows doesn't compile with asan enabled.
if (APPLE OR WINDOWS)
    set(ASAN_DEFAULT OFF)
else()
    set(ASAN_DEFAULT ON)
endif()

# ASAN causes uTox to be slower so do no use it for release builds
if (CMAKE_BUILD_TYPE MATCHES "Release")
   set(ASAN_DEFAULT OFF)
endif()

###########
# Options #
###########

option(UTOX_STATIC        "Link uTox statically"                                 ${STATIC_DEFAULT} )
option(TOXCORE_STATIC     "Build uTox with the static version of Toxcore"        ${STATIC_DEFAULT} )
option(ENABLE_ASAN        "Enable Address Sanitizer on debug builds"               ${ASAN_DEFAULT} )
option(ENABLE_TESTS       "Whether to build test binaries (currently Unix-like OSes only)"      ON )
option(ENABLE_WERROR      "Error on Warning, whether to put -Werror flag to the compiler"       OFF)
option(ENABLE_FILTERAUDIO "Enable Filter Audio"                                                 ON )
option(ENABLE_AUTOUPDATE  "Enable Auto-updater"                                                 OFF)
option(ENABLE_LTO         "Enable link time optimizations"                                      ON )


#################################
# Include toolchain if required #
#################################

if(WINDOWS AND NOT CROSS_COMPILING)
    include(cmake/win.cmake)

    if(ARCH_64)
        # Helping Cygwin out again..
        set(WIN64 TRUE)
    endif()
elseif(APPLE)
    include(cmake/macOS.cmake)
endif()


#######################################################################
# CMake Settings
#######################################################################
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

# make version available in C files
configure_file(${uTox_SOURCE_DIR}/src/branding.h.in
               ${uTox_SOURCE_DIR}/src/branding.h)
configure_file(${uTox_SOURCE_DIR}/src/cocoa/Info.plist.in
               ${uTox_SOURCE_DIR}/src/cocoa/Info.plist)
configure_file(${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml.in
               ${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml)
configure_file(${uTox_SOURCE_DIR}/src/utox.1.in
               ${uTox_SOURCE_DIR}/src/utox.1)

if(${CMAKE_BUILD_TYPE} MATCHES Debug)
    execute_process(COMMAND git describe --abbrev=8 --dirty --always --tags
                    OUTPUT_VARIABLE GIT_VERSION)
    string(REPLACE "\n" " " GIT_VERSION ${GIT_VERSION})
endif()

#######################################################################
# C compiler flags
#######################################################################

set(CMAKE_C_STANDARD 11) # this requires at least cmake 3.1

include(CheckCCompilerFlag)

# add compiler flag for all build types
function(add_cflag flag)
    string(REGEX REPLACE "[^a-zA-Z0-9_]" "_" var ${flag})
    if(NOT DEFINED HAVE_C${var})
        message(STATUS "checking for C compiler flag: ${flag}")
    endif()
    set(CMAKE_REQUIRED_QUIET TRUE)

    check_c_compiler_flag("${flag}" HAVE_C${var} QUIET)
    if(HAVE_C${var})
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}" PARENT_SCOPE)
    else()
        message(STATUS "Warning: Can't find flag ${flag}")
    endif()
endfunction()

# Grab environment CFLAGS.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} $ENV{CFLAGS}")

# Warn on non-ISO C.
#add_cflag("-pedantic") # throws a lot of warning, quite sure we do not want this at current state.
## Add all warning flags we can.
add_cflag("-Wall")
add_cflag("-Wextra")
add_cflag("-Wpointer-arith")
add_cflag("-Wimplicit-fallthrough=5")

## Warnings we don't tolerate
add_cflag("-Werror=implicit-function-declaration")

## Warnings we don't care about
add_cflag("-Wformat=0")
add_cflag("-Wno-misleading-indentation")

## Everything Else
add_cflag("-fno-strict-aliasing")
add_cflag("-fPIC")

## Optimization Flags

# Fix GNU stack
if(CMAKE_C_COMPILER_ID MATCHES "GNU")
    # Have ld strip the symbols from Release and MinSizeRel build types.
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -Os")
    set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Os -s")

    if(LINUX)
        # enable Link Time Optimization on gcc (linux only currently)
        # TODO someone should figure out how this works on windows, or we need to have gitlab-ci for GCC
        if(ENABLE_LTO)
            ## -flto is a flag that needs to exist at link time as well,
            #  so we use some hacky save/restore to help cmake.
            set(SAVE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
            set(CMAKE_REQUIRED_LIBRARIES "-flto")
            add_cflag("-flto")
            set(CMAKE_REQUIRED_LIBRARIES "${SAVE_CMAKE_REQUIRED_LIBRARIES}")
        endif()

        set(CMAKE_AR "gcc-ar")
        set(CMAKE_RANLIB "gcc-ranlib")

        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack")
    endif()
elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
    # Disable warning for `= { 0 }` in Clang.
    # Remove once they've resolved https://bugs.llvm.org//show_bug.cgi?id=21689
    add_cflag("-Wno-missing-field-initializers")

    # Enable Link Time Optimization on Clang
    if(ENABLE_LTO)
        ## -flto is a flag that needs to exist at link time as well,
        #  so we use some hacky save/restore to help cmake.
        set(SAVE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
        set(CMAKE_REQUIRED_LIBRARIES "-flto")
        add_cflag("-flto")
        set(CMAKE_REQUIRED_LIBRARIES "${SAVE_CMAKE_REQUIRED_LIBRARIES}")
    endif()

    # Have ld strip the symbols from Release and MinSizeRel build types. (-Oz is clang specific)
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -Os")
    set(CMAKE_C_FLAGS_MINSIZEREL "${CMAKE_C_FLAGS_MINSIZEREL} -Oz -s")

    if(FREEBSD)
        set(LIBRARIES ${LIBRARIES} "cxxrt")
    endif()

    if(NOT ENABLE_ASAN)
        if(NOT APPLE)
            add_cflag("-fsanitize=safe-stack")
        endif()
    endif()
else()
    message(STATUS "Unknown compiler name: You may have to set up your compiler flags yourself.")
endif()

# set define for GIT_VERSION
if(GIT_VERSION)
    add_cflag("-DGIT_VERSION='\"${GIT_VERSION}\"'")
endif()


#######################################################################
# Build options
#######################################################################

# https://github.com/google/sanitizers/wiki/AddressSanitizer
if (ENABLE_ASAN)
    set(SAVE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
    set(CMAKE_REQUIRED_LIBRARIES "-fsanitize=address")
    add_cflag("-fsanitize=address")
    add_cflag("-fno-omit-frame-pointer")
    set(CMAKE_REQUIRED_LIBRARIES "${SAVE_CMAKE_REQUIRED_LIBRARIES}")
endif()

if(ENABLE_WERROR)
    add_cflag("-Werror")
endif()

if(UTOX_STATIC)
    if(UNIX)
        add_cflag("-Wl -Bstatic -lopus -lopenal -lfilteraudio -Bdynamic -lrt -lm -lpthread -ldl")
    else()
        add_cflag("-static")
    endif()
endif()

if(ENABLE_AUTOUPDATE)
    add_cflag("-DENABLE_AUTOUPDATE=1")
endif()

if(ENABLE_FILTERAUDIO)
    add_cflag("-DAUDIO_FILTERING=1")
endif()

find_package(libtox REQUIRED)
include_directories(${LIBTOX_INCLUDE_DIRS})
set(LIBRARIES ${LIBRARIES} ${LIBTOX_LIBRARIES})

find_package(libsodium REQUIRED)
include_directories(${LIBSODIUM_INCLUDE_DIRS})
set(LIBRARIES ${LIBRARIES} ${LIBSODIUM_LIBRARIES})

find_package(libvpx REQUIRED)
include_directories(${LIBVPX_INCLUDE_DIRS})
set(LIBRARIES ${LIBRARIES} ${LIBVPX_LIBRARIES})

include_directories(SYSTEM third-party/stb)
include_directories(SYSTEM third-party/minini/dev)
include_directories(SYSTEM third-party/qrcodegen/c)

# Protip, you must use a different directory for each build target...
# -DMAKE_TOOLCHAIN_FILE has no effect unless the target directory is empty
# 1.5 hours to learn this...
if(WIN32)
    if (CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "MinSizeRel")
        set(GUI_TYPE WIN32)
    endif()

    link_directories(${CMAKE_PREFIX_PATH}/lib)

    # Windows icons
    enable_language(RC)
    set(WINDOWS_ICON src/windows/utox.rc)

    add_subdirectory(src/windows)
elseif(APPLE)
    set(GUI_TYPE MACOSX_BUNDLE)

    add_definitions("-x objective-c")
    add_subdirectory(src/cocoa)
elseif(UNIX)
    find_package(X11 REQUIRED)
    include_directories(${X11_INCLUDE_DIR})

    add_subdirectory(src/xlib)

    if(LINUX)
        # Required for v4l (at least in the Linux static builds on Jenkins)
        set(LIBRARIES ${LIBRARIES} "rt")
    endif()
endif()

# Acquire 3rd party headers
find_path(STBI_INCLUDE_DIR NAMES stb_image.h stb_image_write.h PATHS third-party/stb)
if((NOT STBI_INCLUDE_DIR) OR (NOT EXISTS ${STBI_INCLUDE_DIR}))
    message("STBI not found")
    execute_process(COMMAND git submodule update --init -- third-party/stb WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    # set FOO_INCLUDE_DIR properly
    set(STBI_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/third-party/stb/ CACHE PATH "stbi include directory")
endif()


# include utoxLAYOUT
add_subdirectory(src/layout)
# include utoxUI
add_subdirectory(src/ui)
# include utoxAV
add_subdirectory(src/av)

#######################################################################
# :: uTox main
#######################################################################
add_executable(utox ${GUI_TYPE}
    src/avatar.c
    src/chatlog.c
    src/chrono.c
    src/command_funcs.c
    src/commands.c
    src/devices.c
    src/file_transfers.c
    src/filesys.c
    src/flist.c
    src/friend.c
    src/groups.c
    src/inline_video.c
    src/logging.c
    src/main.c
    src/messages.c
    src/notify.c
    src/qr.c
    src/screen_grab.c
    src/self.c
    src/settings.c
    src/sized_string.h
    src/stb.c
    src/text.c
    src/theme.c
    src/tox.c
    src/tox_callbacks.c
    src/ui.c
    src/ui_i18n.c
    src/updater.c
    src/utox.c
    src/window.c
    third-party/minini/dev/minIni.c
    third-party/qrcodegen/c/qrcodegen.c

    ${WINDOWS_ICON}
    ${APPLE_FILES}
)

target_link_libraries(utox
    utoxAV
    utoxNATIVE
    utoxUI
    ${LIBRARIES}
    pthread
    m
)

set_property(TARGET utox PROPERTY C_STANDARD 11)

if(APPLE)
    set_target_properties(utox PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${uTox_SOURCE_DIR}/src/cocoa/Info.plist")
    # check that the app is valid and when the app is static
    # also check that it does not depend on external libs (system libs excepted)
    install(CODE "include(BundleUtilities)
        verify_app(${CMAKE_BINARY_DIR}/utox.app)
        if(UTOX_STATIC OR TOXCORE_STATIC)

=== tests/CMakeLists.txt ===
project(utoxTESTS LANGUAGES C)
include(CTest)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

find_package(Check REQUIRED)
link_directories(${CHECK_LIBRARY_DIRS})

function(make_test name)
    add_executable(test_${name} test_${name}.c)
    set_target_properties(test_${name} PROPERTIES COMPILE_FLAGS "-Wno-unused-parameter")
    target_link_libraries(test_${name} utox-test-mock ${CHECK_LIBRARIES})
    add_test(NAME test_${name} COMMAND test_${name})
endfunction()

configure_file(${utoxTESTS_SOURCE_DIR}/run_tests.sh
               ${uTox_BINARY_DIR}/run_tests.sh)

#
# generic testing defines
#
include_directories("../src")

add_library(utox-test-mock
            mock/mock_filesys.c
            mock/mock_settings.c
            mock/mock_logging.c
            mock/mock_threads.c
            mock/mock_system_calls.c
)
set_target_properties(utox-test-mock PROPERTIES COMPILE_FLAGS "-Wno-unused-parameter")
target_link_libraries(utox-test-mock pthread)

#
# tests
#
# TODO add a cmake macro for adding tests, this will be too verbose if we add more.
make_test(chatlog)

if(ENABLE_AUTOUPDATE)
  make_test(updater)
      target_link_libraries(test_updater sodium)
endif()

make_test(chrono)

=== src/av/CMakeLists.txt ===
project(utoxAV LANGUAGES C)

add_library(utoxAV STATIC
    utox_av.c
    audio.c
    video.c
    filter_audio.c
    )

if(WIN32)
    target_link_libraries(utoxAV OpenAL32) # Windows needs to be linked against OpenAL32
elseif(APPLE)
    find_package(libopus REQUIRED)
    include_directories(${LIBOPUS_INCLUDE_DIRS})
    target_link_libraries(utoxAV ${LIBOPUS_LIBRARIES}) # Link OSX against opus
else()
    # Both openal and opus are required for the static Linux builds on Jenkins.
    find_package(libopus REQUIRED)
    include_directories(${LIBOPUS_INCLUDE_DIRS})
    target_link_libraries(utoxAV ${LIBOPUS_LIBRARIES})
    find_package(OpenAL REQUIRED)
    include_directories(${OPENAL_INCLUDE_DIR})
    target_link_libraries(utoxAV ${OPENAL_LIBRARY})
endif()

if(ENABLE_FILTERAUDIO)
    find_package(libfilteraudio REQUIRED)
    include_directories(${LIBFILTERAUDIO_INCLUDE_DIRS})
    target_link_libraries(utoxAV ${LIBFILTERAUDIO_LIBRARIES})
endif()

=== src/layout/CMakeLists.txt ===
project(utoxLAYOUT LANGUAGES C)

add_library(utoxLAYOUT STATIC
    friend.c
    group.c
    notify.c
    settings.c
    sidebar.c
    userbadge.c
    background.c
    tray.c
    )

=== src/ui/CMakeLists.txt ===
project(utoxUI LANGUAGES C)

add_library(utoxUI STATIC
    button.c
    contextmenu.c
    contextmenu.h
    draw.h
    dropdown.c
    dropdown.h
    edit.c
    edit.h
    scrollable.c
    scrollable.h
    svg.c
    svg.h
    switch.c
    switch.h
    text.c
    text.h
    tooltip.c
    tooltip.h
    )

target_link_libraries(utoxUI utoxLAYOUT)

=== src/windows/CMakeLists.txt ===
project(utoxNATIVE LANGUAGES C)

option(WIN_XP_LEGACY "Compile Legacy code for Windows XP" OFF)
if(WIN_XP_LEGACY)
    add_cflag("-D__WIN_LEGACY=1")
endif()

#########################################
## Native Icon data
#########################################
enable_language(RC)

#########################################
## Native Interface
#########################################
add_library(utoxNATIVE STATIC
    audio.c
    dnd.c
    drawing.c
    events.c
    filesys.c
    main.c
    main.h
    notify.c
    os_video.c
    screen_grab.c
    utf8.c
    video.c
    window.c

    ## The following two have ifdef's for __WIN_LEGACY
    #  We include them both here even though only one will compile with content
    main.XP.c
    main.7.c
    )

target_link_libraries(utoxNATIVE
    iphlpapi    ws2_32      gdi32       msimg32
    dnsapi      comdlg32    winmm       ole32
    oleaut32    strmiids    shell32     opus
    )

set(WINDOWS_ICON utox.rc)

=== src/xlib/CMakeLists.txt ===
project(utoxNATIVE LANGUAGES C)

option(ENABLE_DBUS "Compile with dbus notification support" ON)


if(ENABLE_DBUS)
    find_package(DBus REQUIRED)
    include_directories(${DBUS_INCLUDE_DIRS})
    add_cflag("-DHAVE_DBUS=1")
endif()

#########################################
## Native Icon data
#########################################
add_custom_command(OUTPUT icon.o
    COMMAND cd ${uTox_SOURCE_DIR}/ && ld -r -b binary -o ${utoxNATIVE_BINARY_DIR}/icon.o icons/utox-128x128.png
    DEPENDS ../../icons/utox-128x128.png )
set_source_files_properties( icon.o PROPERTIES EXTERNAL_OBJECT true GENERATED true )
add_library(icon STATIC icon.o)
set_target_properties( icon PROPERTIES LINKER_LANGUAGE C )

#########################################
## Native Interface
#########################################
add_library(utoxNATIVE STATIC
    audio.c
    dbus.c
    dbus.h
    drawing.c
    event.c
    filesys.c
    freetype.c
    freetype.h
    gtk.c
    keysym2ucs.h
    main.c
    main.h
    mmenu.c
    mmenu.h
    screen_grab.c
    tray.c
    v4l.c
    video.c
    window.c

    ../posix/filesys.c
    )

find_package(Freetype REQUIRED)
include_directories(${FREETYPE_INCLUDE_DIRS})
message("Found Freetype version ${FREETYPE_VERSION_STRING}")
message("Freetype include: ${FREETYPE_INCLUDE_DIRS}")
message("Freetype library: ${FREETYPE_LIBRARIES}")

find_package(libfontconfig REQUIRED)
include_directories("${LIBFONTCONFIG_INCLUDE_DIRS}")
message("FontConfig include: ${LIBFONTCONFIG_INCLUDE_DIRS}")
message("FontConfig library: ${LIBFONTCONFIG_LIBRARIES}")

message("X include:         ${X11_INCLUDE_DIR}")
message("X library:         ${X11_LIBRARIES}")
message("Xrender include:   ${X11_Xrender_INCLUDE_PATH}")
message("Xrender library:   ${X11_Xrender_LIB}")

find_package(libv4lconvert REQUIRED)
include_directories("${LIBV4LCONVERT_INCLUDE_DIRS}")
message("V4Lconvert include: ${LIBV4LCONVERT_INCLUDE_DIRS}")
message("V4Lconvert library: ${LIBV4LCONVERT_LIBRARIES}")

if(ENABLE_DBUS AND DBUS_LIBRARIES)
    message("DBus include:  ${DBUS_INCLUDE_DIRS}")
    message("DBus library:  ${DBUS_LIBRARIES}")
else()
    set(DBUS_LIBRARIES "")
endif()

target_link_libraries(utoxNATIVE
        icon
        ${LIBV4LCONVERT_LIBRARIES}
        ${LIBFONTCONFIG_LIBRARIES}
        ${X11_LIBRARIES}
        ${X11_Xrender_LIB}
        ${FREETYPE_LIBRARIES}
        ${DBUS_LIBRARIES}
        )

if(LINUX OR NETBSD)
    target_link_libraries(utoxNATIVE
        resolv
        )
endif()

if(LINUX)
    target_link_libraries(utoxNATIVE
        dl
        )
endif()

include(GNUInstallDirs)

install(FILES
    ../utox.desktop
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications"
    )

install(FILES
    ../utox.1
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
    )

install(FILES
   ../../icons/utox-14x14.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/14x14/apps"
    )

install(FILES
   ../../icons/utox-16x16.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps"
    )

install(FILES
   ../../icons/utox-22x22.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/22x22/apps"
    )

install(FILES
   ../../icons/utox-24x24.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/24x24/apps"
    )

install(FILES
   ../../icons/utox-32x32.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps"
    )

install(FILES
   ../../icons/utox-36x36.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/36x36/apps"
    )

install(FILES
   ../../icons/utox-48x48.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps"
    )

install(FILES
   ../../icons/utox-64x64.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps"
    )

install(FILES
   ../../icons/utox-72x72.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/72x72/apps"
    )

install(FILES
   ../../icons/utox-96x96.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/96x96/apps"
    )

install(FILES
   ../../icons/utox-128x128.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/128x128/apps"
    )

install(FILES
   ../../icons/utox-256x256.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/256x256/apps"
    )

install(FILES
   ../../icons/utox-512x512.png
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/512x512/apps"
    )

install(FILES
   ../../icons/utox.svg
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps"
    )

=== debian/changelog ===
utox (0.17.1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.4.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Fri, 27 Sep 2019 21:44:24 +0800

=== debian/control ===
Source: utox
Section: net
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 check,
 libvpx-dev,
 libfontconfig1-dev,
 libdbus-1-dev,
 libv4l-dev,
 libxrender-dev,
 libopenal-dev,
 libxext-dev,
 libtoxcore-dev,
 libstb-dev,
 libminini-dev,
 libqrcodegen-dev,
Standards-Version: 4.4.0
Homepage: https://utox.io
Vcs-Git: https://salsa.debian.org/yangfl-guest/uTox.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/uTox

Package: utox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightest and fluffiest Tox client
 µTox is the lightweight client with minimal dependencies; it not only looks
 pretty, it runs fast! µTox is available for Windows, OS X, and Linux (Android
 support is experimental), with full support for chat, file transfers,
 audio/video calling, and desktop sharing (both as video and inline
 screenshots). It also supports text group chats with audio groups pending the
 next Toxcore update.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk


%:
	dh $@

# disable link time optimizations if compiling takes too long
# -DENABLE_LTO=OFF
override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_ASAN=OFF \
		-DENABLE_FILTERAUDIO=OFF \
		-DENABLE_TESTS=ON \
		-DENABLE_LTO=OFF

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%uTox-$1.tar.gz%,pgpsigurlmangle=s%archive/v(\d[\d.]*)\.tar\.gz%releases/download/v$1/uTox-$1.tar.gz.asc%" \
   https://github.com/uTox/uTox/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## utox 0.17.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,10 @@
 
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "17")
-set(PROJECT_VERSION_PATCH "1")
+set(PROJECT_VERSION_PATCH "2")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
-set(PROJECT_COPYRIGHT "Copyleft 2019 uTox contributors. Some rights reserved.")
+set(PROJECT_COPYRIGHT "Copyleft 2020 uTox contributors. Some rights reserved.")
 
 string(TIMESTAMP BUILD_YEAR "%Y" UTC)
 string(TIMESTAMP BUILD_MONTH "%B" UTC)
@@ -80,13 +80,17 @@
 # Options #
 ###########
 
-option(UTOX_STATIC        "Link uTox statically"                                 ${STATIC_DEFAULT} )
-option(TOXCORE_STATIC     "Build uTox with the static version of Toxcore"        ${STATIC_DEFAULT} )
+option(STATIC_ALL         "Enable all STATIC_* options"                          ${STATIC_DEFAULT} )
+option(STATIC_TOXCORE     "Link toxcore statically"                              ${STATIC_DEFAULT} )
+option(STATIC_DBUS        "Link dbus statically"                                 ${STATIC_DEFAULT} )
+option(STATIC_FILTERAUDIO "Link filteraudio statically"                          ${STATIC_DEFAULT} )
+option(STATIC_OPUS        "Link opus statically"                                 ${STATIC_DEFAULT} )
+option(STATIC_SODIUM      "Link sodium statically"                               ${STATIC_DEFAULT} )
+option(STATIC_VPX         "Link vpx statically"                                  ${STATIC_DEFAULT} )
 option(ENABLE_ASAN        "Enable Address Sanitizer on debug builds"               ${ASAN_DEFAULT} )
 option(ENABLE_TESTS       "Whether to build test binaries (currently Unix-like OSes only)"      ON )
 option(ENABLE_WERROR      "Error on Warning, whether to put -Werror flag to the compiler"       OFF)
 option(ENABLE_FILTERAUDIO "Enable Filter Audio"                                                 ON )
-option(ENABLE_AUTOUPDATE  "Enable Auto-updater"                                                 OFF)
 option(ENABLE_LTO         "Enable link time optimizations"                                      ON )
 
 
@@ -151,9 +155,6 @@
     endif()
 endfunction()
 
-# Grab environment CFLAGS.
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} $ENV{CFLAGS}")
-
 # Warn on non-ISO C.
 #add_cflag("-pedantic") # throws a lot of warning, quite sure we do not want this at current state.
 ## Add all warning flags we can.
@@ -172,6 +173,9 @@
 ## Everything Else
 add_cflag("-fno-strict-aliasing")
 add_cflag("-fPIC")
+if(NOT WINDOWS) # TODO fix windows
+    add_cflag("-fno-common")
+endif()
 
 ## Optimization Flags
 
@@ -253,16 +257,12 @@
     add_cflag("-Werror")
 endif()
 
-if(UTOX_STATIC)
+if(STATIC_ALL)
     if(UNIX)
         add_cflag("-Wl -Bstatic -lopus -lopenal -lfilteraudio -Bdynamic -lrt -lm -lpthread -ldl")
     else()
         add_cflag("-static")
     endif()
-endif()
-
-if(ENABLE_AUTOUPDATE)
-    add_cflag("-DENABLE_AUTOUPDATE=1")
 endif()
 
 if(ENABLE_FILTERAUDIO)
@@ -362,11 +362,11 @@
     src/stb.c
     src/text.c
     src/theme.c
+    src/theme_tables.c
     src/tox.c
     src/tox_callbacks.c
     src/ui.c
     src/ui_i18n.c
-    src/updater.c
     src/utox.c
     src/window.c
     third-party/minini/dev/minIni.c
@@ -388,9 +388,3 @@
 set_property(TARGET utox PROPERTY C_STANDARD 11)
 
 if(APPLE)
-    set_target_properties(utox PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${uTox_SOURCE_DIR}/src/cocoa/Info.plist")
-    # check that the app is valid and when the app is static
-    # also check that it does not depend on external libs (system libs excepted)
-    install(CODE "include(BundleUtilities)
-        verify_app(${CMAKE_BINARY_DIR}/utox.app)
-        if(UTOX_STATIC OR TOXCORE_STATIC)

=== src/ui/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
     button.c
     contextmenu.c
     contextmenu.h
+    draw.c
     draw.h
     dropdown.c
     dropdown.h

=== src/windows/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,4 @@
 project(utoxNATIVE LANGUAGES C)
-
-option(WIN_XP_LEGACY "Compile Legacy code for Windows XP" OFF)
-if(WIN_XP_LEGACY)
-    add_cflag("-D__WIN_LEGACY=1")
-endif()
 
 #########################################
 ## Native Icon data
@@ -28,9 +23,6 @@
     video.c
     window.c
 
-    ## The following two have ifdef's for __WIN_LEGACY
-    #  We include them both here even though only one will compile with content
-    main.XP.c
     main.7.c
     )

=== debian/changelog ===
utox (0.17.2-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0
  * Bump debhelper compat to 13
  * Add upstream metadata

 -- Yangfl <mmyangfl@gmail.com>  Sat, 25 Jul 2020 02:46:08 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  cmake,
  check,
  libvpx-dev,
@@ -17,7 +17,8 @@
  libstb-dev,
  libminini-dev,
  libqrcodegen-dev,
-Standards-Version: 4.4.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://utox.io
 Vcs-Git: https://salsa.debian.org/yangfl-guest/uTox.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/uTox

=== debian/rules ===
--- 
+++ 
@@ -5,14 +5,14 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
-
-include /usr/share/dpkg/pkg-info.mk
-include /usr/share/dpkg/architecture.mk
+export DEB_LDFLAGS_MAINT_APPEND =
 
 
 %:
 	dh $@
+
+execute_after_dh_clean:
+	$(RM) src/cocoa/Info.plist src/utox.1
 
 # disable link time optimizations if compiling takes too long
 # -DENABLE_LTO=OFF

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%uTox-$1.tar.gz%,pgpsigurlmangle=s%archive/v(\d[\d.]*)\.tar\.gz%releases/download/v$1/v$1.tar.gz.asc%" \
   https://github.com/uTox/uTox/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## utox 0.18.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,11 +6,11 @@
 #####################
 
 set(PROJECT_VERSION_MAJOR "0")
-set(PROJECT_VERSION_MINOR "17")
-set(PROJECT_VERSION_PATCH "2")
+set(PROJECT_VERSION_MINOR "18")
+set(PROJECT_VERSION_PATCH "1")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
-set(PROJECT_COPYRIGHT "Copyleft 2020 uTox contributors. Some rights reserved.")
+set(PROJECT_COPYRIGHT "Copyleft 2021 uTox contributors. Some rights reserved.")
 
 string(TIMESTAMP BUILD_YEAR "%Y" UTC)
 string(TIMESTAMP BUILD_MONTH "%B" UTC)
@@ -29,16 +29,16 @@
 if(WIN32)
     set(WINDOWS TRUE)
 elseif(APPLE)
-    if(CMAKE_SYSTEM_NAME MATCHES ".*MacOS.*")
+    if(CMAKE_SYSTEM_NAME MATCHES "MacOS")
         set(CMAKE_OSX_DEPLOYMENT_TARGET 10.6 CACHE STRING "Minimum OS X deployment version")
         set(MACOSX TRUE)
     endif()
 elseif(UNIX)
-    if(CMAKE_SYSTEM_NAME MATCHES ".*Linux")
+    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
         set(LINUX TRUE)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "kNetBSD.*|NetBSD.*")
+    elseif(CMAKE_SYSTEM_NAME MATCHES "NetBSD")
         set(NETBSD TRUE)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "kFreeBSD.*|FreeBSD")
+    elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
         set(FREEBSD TRUE)
     endif()
 endif()
@@ -122,8 +122,8 @@
                ${uTox_SOURCE_DIR}/src/cocoa/Info.plist)
 configure_file(${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml.in
                ${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml)
-configure_file(${uTox_SOURCE_DIR}/src/utox.1.in
-               ${uTox_SOURCE_DIR}/src/utox.1)
+configure_file(${uTox_SOURCE_DIR}/man/utox.1.in
+               ${uTox_SOURCE_DIR}/man/utox.1)
 
 if(${CMAKE_BUILD_TYPE} MATCHES Debug)
     execute_process(COMMAND git describe --abbrev=8 --dirty --always --tags
@@ -173,9 +173,7 @@
 ## Everything Else
 add_cflag("-fno-strict-aliasing")
 add_cflag("-fPIC")
-if(NOT WINDOWS) # TODO fix windows
-    add_cflag("-fno-common")
-endif()
+add_cflag("-fno-common")
 
 ## Optimization Flags
 
@@ -273,17 +271,17 @@
 include_directories(${LIBTOX_INCLUDE_DIRS})
 set(LIBRARIES ${LIBRARIES} ${LIBTOX_LIBRARIES})
 
-find_package(libsodium REQUIRED)
-include_directories(${LIBSODIUM_INCLUDE_DIRS})
-set(LIBRARIES ${LIBRARIES} ${LIBSODIUM_LIBRARIES})
+if(STATIC_ALL OR STATIC_TOXCORE OR STATIC_SODIUM OR APPLE)
+    find_package(libsodium REQUIRED)
+    include_directories(${LIBSODIUM_INCLUDE_DIRS})
+    set(LIBRARIES ${LIBRARIES} ${LIBSODIUM_LIBRARIES})
+endif()
 
 find_package(libvpx REQUIRED)
 include_directories(${LIBVPX_INCLUDE_DIRS})
 set(LIBRARIES ${LIBRARIES} ${LIBVPX_LIBRARIES})
 
-include_directories(SYSTEM third-party/stb)
-include_directories(SYSTEM third-party/minini/dev)
-include_directories(SYSTEM third-party/qrcodegen/c)
+add_subdirectory(third_party)
 
 # Protip, you must use a different directory for each build target...
 # -DMAKE_TOOLCHAIN_FILE has no effect unless the target directory is empty
@@ -318,12 +316,10 @@
 endif()
 
 # Acquire 3rd party headers
-find_path(STBI_INCLUDE_DIR NAMES stb_image.h stb_image_write.h PATHS third-party/stb)
+find_path(STBI_INCLUDE_DIR NAMES stb_image.h stb_image_write.h PATHS third_party/stb/stb)
 if((NOT STBI_INCLUDE_DIR) OR (NOT EXISTS ${STBI_INCLUDE_DIR}))
     message("STBI not found")
-    execute_process(COMMAND git submodule update --init -- third-party/stb WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
-    # set FOO_INCLUDE_DIR properly
-    set(STBI_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/third-party/stb/ CACHE PATH "stbi include directory")
+    execute_process(COMMAND git submodule update --init -- third_party/stb/stb WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
 endif()
 
 
@@ -358,8 +354,6 @@
     src/screen_grab.c
     src/self.c
     src/settings.c
-    src/sized_string.h
-    src/stb.c
     src/text.c
     src/theme.c
     src/theme_tables.c
@@ -369,8 +363,6 @@
     src/ui_i18n.c
     src/utox.c
     src/window.c
-    third-party/minini/dev/minIni.c
-    third-party/qrcodegen/c/qrcodegen.c
 
     ${WINDOWS_ICON}
     ${APPLE_FILES}
@@ -383,8 +375,17 @@
     ${LIBRARIES}
     pthread
     m
+    stb
+    minini
+    qrcodegen
 )
 
 set_property(TARGET utox PROPERTY C_STANDARD 11)
 
 if(APPLE)
+    set_target_properties(utox PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${uTox_SOURCE_DIR}/src/cocoa/Info.plist")
+    # check that the app is valid and when the app is static
+    # also check that it does not depend on external libs (system libs excepted)
+    install(CODE "include(BundleUtilities)
+        verify_app(${CMAKE_BINARY_DIR}/utox.app)
+        if(STATIC_ALL OR STATIC_TOXCORE)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -37,9 +37,4 @@
 # TODO add a cmake macro for adding tests, this will be too verbose if we add more.
 make_test(chatlog)
 
-if(ENABLE_AUTOUPDATE)
-  make_test(updater)
-      target_link_libraries(test_updater sodium)
-endif()
-
 make_test(chrono)

=== third_party/CMakeLists.txt ===
add_cflag("-Wno-error")

add_subdirectory(minini)
add_subdirectory(qrcodegen)
add_subdirectory(stb)

=== src/cocoa/CMakeLists.txt ===
project(utoxNATIVE LANGUAGES C)

add_library(utoxNATIVE STATIC
    ../posix/filesys.c

    drawing.m
    grabdesktop.m
    interaction.m
    main.m
    MainMenu.xib
    video.m

    window.c
    )

target_link_libraries(utoxNATIVE
    PUBLIC
        "-framework AppKit"
        "-framework ApplicationServices"
        "-framework AVFoundation"
        "-framework Cocoa"
        "-framework CoreData"
        "-framework CoreFoundation"
        "-framework CoreGraphics"
        "-framework CoreMedia"
        "-framework CoreText"
        "-framework CoreVideo"
        "-framework Foundation"
        "-framework OpenAL"
        "-framework OpenGL"
        "-framework QuartzCore"
        -lresolv
    PRIVATE
        stb
)

=== src/ui/CMakeLists.txt ===
project(utoxUI LANGUAGES C)

add_library(utoxUI STATIC
    button.c
    contextmenu.c
    draw.c
    dropdown.c
    edit.c
    scrollable.c
    svg.c
    switch.c
    text.c
    tooltip.c
    )

target_link_libraries(utoxUI utoxLAYOUT)

=== src/windows/CMakeLists.txt ===
--- 
+++ 
@@ -15,21 +15,21 @@
     events.c
     filesys.c
     main.c
-    main.h
     notify.c
     os_video.c
     screen_grab.c
     utf8.c
     video.c
     window.c
-
-    main.7.c
     )
 
 target_link_libraries(utoxNATIVE
-    iphlpapi    ws2_32      gdi32       msimg32
-    dnsapi      comdlg32    winmm       ole32
-    oleaut32    strmiids    shell32     opus
-    )
+    PUBLIC
+        iphlpapi    ws2_32      gdi32       msimg32
+        dnsapi      comdlg32    winmm       ole32
+        oleaut32    strmiids    shell32     opus
+    PRIVATE
+        stb
+)
 
 set(WINDOWS_ICON utox.rc)

=== src/xlib/CMakeLists.txt ===
--- 
+++ 
@@ -24,19 +24,14 @@
 #########################################
 add_library(utoxNATIVE STATIC
     audio.c
-    dbus.c
-    dbus.h
+    $<$<BOOL:${ENABLE_DBUS}>:dbus.c>
     drawing.c
     event.c
     filesys.c
     freetype.c
-    freetype.h
     gtk.c
-    keysym2ucs.h
     main.c
-    main.h
-    mmenu.c
-    mmenu.h
+    $<$<BOOL:${ENABLE_UNITY_MMENU}>:mmenu.c>
     screen_grab.c
     tray.c
     v4l.c
@@ -75,6 +70,7 @@
 endif()
 
 target_link_libraries(utoxNATIVE
+    PUBLIC
         icon
         ${LIBV4LCONVERT_LIBRARIES}
         ${LIBFONTCONFIG_LIBRARIES}
@@ -82,18 +78,22 @@
         ${X11_Xrender_LIB}
         ${FREETYPE_LIBRARIES}
         ${DBUS_LIBRARIES}
-        )
+    PRIVATE
+        stb
+)
 
 if(LINUX OR NETBSD)
     target_link_libraries(utoxNATIVE
-        resolv
-        )
+        PUBLIC
+            resolv
+    )
 endif()
 
 if(LINUX)
     target_link_libraries(utoxNATIVE
-        dl
-        )
+        PUBLIC
+            dl
+    )
 endif()
 
 include(GNUInstallDirs)
@@ -104,7 +104,7 @@
     )
 
 install(FILES
-    ../utox.1
+    ../../man/utox.1
     DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
     )

=== third_party/minini/CMakeLists.txt ===
project(minini LANGUAGES C)

add_library(${PROJECT_NAME} STATIC
    minini/dev/minIni.c
)

target_include_directories(${PROJECT_NAME}
    SYSTEM PUBLIC minini/dev
)

=== third_party/qrcodegen/CMakeLists.txt ===
project(qrcodegen LANGUAGES C)

add_library(${PROJECT_NAME} STATIC
    qrcodegen/c/qrcodegen.c
)

target_include_directories(${PROJECT_NAME}
    SYSTEM PUBLIC qrcodegen/c
)

=== third_party/stb/CMakeLists.txt ===
project(stb LANGUAGES C)

add_library(${PROJECT_NAME} STATIC
    stb.c
)

target_include_directories(${PROJECT_NAME}
    SYSTEM PUBLIC .
)

=== third_party/qrcodegen/qrcodegen/c/Makefile ===
# 
# Makefile for QR Code generator (C)
# 
# Copyright (c) Project Nayuki. (MIT License)
# https://www.nayuki.io/page/qr-code-generator-library
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# - The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
# - The Software is provided "as is", without warranty of any kind, express or
#   implied, including but not limited to the warranties of merchantability,
#   fitness for a particular purpose and noninfringement. In no event shall the
#   authors or copyright holders be liable for any claim, damages or other
#   liability, whether in an action of contract, tort or otherwise, arising from,
#   out of or in connection with the Software or the use or other dealings in the
#   Software.
# 


# ---- Configuration options ----

# External/implicit variables:
# - CC: The C compiler, such as gcc or clang.
# - CFLAGS: Any extra user-specified compiler flags (can be blank).

# Mandatory compiler flags
CFLAGS += -std=c99
# Diagnostics. Adding '-fsanitize=address' is helpful for most versions of Clang and newer versions of GCC.
CFLAGS += -Wall -fsanitize=undefined
# Optimization level
CFLAGS += -O1


# ---- Controlling make ----

# Clear default suffix rules
.SUFFIXES:

# Don't delete object files
.SECONDARY:

# Stuff concerning goals
.DEFAULT_GOAL = all
.PHONY: all clean


# ---- Targets to build ----

LIBSRC = qrcodegen
LIBFILE = libqrcodegen.so
MAINS = qrcodegen-demo qrcodegen-test qrcodegen-worker

# Build all binaries
all: $(LIBFILE) $(MAINS)

# Delete build output
clean:
	rm -f -- $(LIBFILE) $(MAINS)

# Shared library
$(LIBFILE): $(LIBSRC:=.c) $(LIBSRC:=.h)
	$(CC) $(CFLAGS) -fPIC -shared -o $@ $(LIBSRC:=.c)

# Executable files
%: %.c $(LIBFILE)
	$(CC) $(CFLAGS) -o $@ $^

# Special executable
qrcodegen-test: qrcodegen-test.c $(LIBSRC:=.c) $(LIBSRC:=.h)
	$(CC) $(CFLAGS) -DQRCODEGEN_TEST -o $@ $< $(LIBSRC:=.c)

=== third_party/qrcodegen/qrcodegen/cpp/Makefile ===
# 
# Makefile for QR Code generator (C++)
# 
# Copyright (c) Project Nayuki. (MIT License)
# https://www.nayuki.io/page/qr-code-generator-library
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy of
# this software and associated documentation files (the "Software"), to deal in
# the Software without restriction, including without limitation the rights to
# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
# the Software, and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# - The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
# - The Software is provided "as is", without warranty of any kind, express or
#   implied, including but not limited to the warranties of merchantability,
#   fitness for a particular purpose and noninfringement. In no event shall the
#   authors or copyright holders be liable for any claim, damages or other
#   liability, whether in an action of contract, tort or otherwise, arising from,
#   out of or in connection with the Software or the use or other dealings in the
#   Software.
# 


# ---- Configuration options ----

# External/implicit variables:
# - CXX: The C++ compiler, such as g++ or clang++.
# - CXXFLAGS: Any extra user-specified compiler flags (can be blank).

# Mandatory compiler flags
CXXFLAGS += -std=c++11
# Diagnostics. Adding '-fsanitize=address' is helpful for most versions of Clang and newer versions of GCC.
CXXFLAGS += -Wall -fsanitize=undefined
# Optimization level
CXXFLAGS += -O1


# ---- Controlling make ----

# Clear default suffix rules
.SUFFIXES:

# Don't delete object files
.SECONDARY:

# Stuff concerning goals
.DEFAULT_GOAL = all
.PHONY: all clean


# ---- Targets to build ----

LIBSRC = BitBuffer QrCode QrSegment
MAINS = QrCodeGeneratorDemo QrCodeGeneratorWorker

# Build all binaries
all: $(MAINS)

# Delete build output
clean:
	rm -f -- $(MAINS)

# Executable files
%: %.cpp $(LIBSRC:=.cpp) $(LIBSRC:=.hpp)
	$(CXX) $(CXXFLAGS) -o $@ $< $(LIBSRC:=.cpp)

=== debian/changelog ===
utox (0.18.1-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Thu, 28 Jan 2021 17:48:20 +0800

utox (0.18.0-1) unstable; urgency=medium

  * New upstream release
    - Fix segfault on setting proxy settings (Closes: #942081)

 -- Yangfl <mmyangfl@gmail.com>  Tue, 08 Dec 2020 02:15:04 +0800

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libqrcodegen-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
-Homepage: https://utox.io
+Homepage: https://utox.org
 Vcs-Git: https://salsa.debian.org/yangfl-guest/uTox.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/uTox

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%uTox-$1.tar.gz%,downloadurlmangle=s%archive/v?(\d[\d.]*)\.tar\.gz%releases/download/v$1/uTox-$1-full.tar.gz%,pgpsigurlmangle=s%$%.asc%" \
   https://github.com/uTox/uTox/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
